//ADT Binaerbaum mit Zugriffsmethoden
//Informtik Jahrgang12 Marienschule
//Februar 2011
      
public class BinTree
{     
  private Object wurzel;
  private BinTree left;
  private BinTree right;

  //Erzeugt einen leeren Baum.
  public BinTree()
  { 
    this.wurzel = null;
    this.setLeftTree(null);
    this.setRightTree (null);
  }

  //Erzeugt einen Baum mit der Wurzelinhalt pObject und zwei leeren Teilbumen.
  public BinTree (Object pObject)
  {
    this.wurzel = pObject;
    this.setLeftTree (null);
    this.setRightTree (null);
  }
 
  //Erzeugt einen Baum mit der Wurzelinhalt pObject und zwei bergebenen Teilbumen.
  public BinTree (Object pObject, BinTree pLeftTree, BinTree pRightTree)
  {
    this.wurzel = pObject;
    this.setLeftTree (pLeftTree);
    this.setRightTree (pRightTree);
  }
    
  //Kontrolle, ob der Baum leer ist.
  //Liefert genau dann true, wenn der Baum leer ist. Sonst false.
  public boolean isEmpty()
  {
    if (this.wurzel == null)
       return true;
    else
       return false;
  }

  // Der Baum wird geleert
  public void clear()
  {
    this.wurzel = null;
    this.setLeftTree(null);
    this.setRightTree(null);
  }
  
  //Aktualisiert die Wurzel des Baums.
  //Die Wurzel des Baums erhlt Wert von neu.
  //Beide Teilbume sind unbeeinflusst.
  public void setRootItem (Object neu)
  {    
    this.wurzel = neu ;
  }
    
  //Liefert den Wert der Wurzel des Baums.
  //Darf nur bei einem Baum angewendet werden, der nicht leer ist.
  //Wurzel und Teilbaeume bleiben unverndert.
  public Object getRootItem ()
  {
    return this.wurzel;
  }
    
  //Der Teilbaum pTree wird rechts an die Wurzel des Baums angehngt.
  //Darf nur bei einem Baum angewendet werden, der nicht leer ist.
  //Die Wurzel und der linke Teilbaum bleiben unverndert.
  public void setRightTree (BinTree pTree)
  {
    this.right = pTree;
  }
     
  //Der Teilbaum pTree wird links an die Wurzel des Baums angehngt.
  //Darf nur bei einem Baum angewendet werden, der nicht leer ist.
  //Die Wurzel und der rechte Teilbaum bleiben unverndert.
  public void setLeftTree (BinTree pTree)
  {
    this.left = pTree;
  }
    
  //Liefert den rechten Teilbaum des Baums.
  //Darf nur bei einem Baum angewendet werden, der nicht leer ist.
  public BinTree getRightTree ()
  {     
    return this.right;
  }
    
  //Liefert den linken Teilbaum des Baums.
  //Darf nur bei einem Baum angewendet werden, der nicht leer ist.
  public BinTree  getLeftTree ()
  {
    return this.left;
  }
}
