public class OrderedTree extends BinTree
// Marienschule
// Suchbaumklasse mit Zugriffsmethoden
// Informatik Stufe 12, Januar 2011
{

  // Erzeugt einen leeren Suchbaum
  public OrderedTree()
  {
    new BinTree();
  }

  // Liefert genau dann true, wenn der geordneten Baum leer ist, sonst false
  public boolean isEmpty()
  {
    if(super.isEmpty())
      return true;
    else
      return false;
  }

  // pItem wird entsprechend der Ordnungsrelation in den Baum eingeordnet.
  public void insertItem(Item pItem)
  {
    if(this.isEmpty())
    { //in einem leeren Baum als Wurzelinhalt
      this.setRootItem(pItem);
    }
    else if(pItem.isLess((Item) this.getRootItem()))
    { //einzufgender Knoteninhalt ist kleiner als betrachteter Knoteninhalt
      if(this.getLeftTree() == null)
      { //einzufgender Knoten wird zum linken Nachfolgeblatt
        //denn ein linker Teilbaum existiert nicht
        OrderedTree newLeft = new OrderedTree();
        newLeft.setRootItem(pItem);
        newLeft.setLeftTree(null);
        newLeft.setRightTree(null);
        this.setLeftTree(newLeft);
      }
      else
      { //rekursiver Aufruf fr den linken Teilbaum
        ((OrderedTree)this.getLeftTree()).insertItem(pItem);
      }
    }
    else if(pItem.isGreater((Item) this.getRootItem()))
    { //einzufgender Knoteninhalt ist grer als betrachteter Knoteninhalt
      if(this.getRightTree() == null)
      { //einzufgender Knoten wird zum rechten Nachfolgeblatt
        //denn ein rechter Teilbaum existiert nicht
        OrderedTree newRight = new OrderedTree();
        newRight.setRootItem(pItem);
        newRight.setLeftTree(null);
        newRight.setRightTree(null);
        this.setRightTree(newRight);
      }
      else
      { //rekursiver Aufruf fr den rechten Teilbaum
       ((OrderedTree)this.getRightTree()).insertItem(pItem);
      }
    }
    else if(pItem.isEqual((Item) this.getRootItem()))
    {

    }
  }
  
  // Falls ein bezglich der verwendeten Ordnungsrelation mit pItem berein-
  // stimmendes Objekt im geordneten Baum enthalten ist, liefert die Anfrage
  // dieses, ansonsten wird null zurckgegeben.
  public Item searchItem (Item pItem)
  {
    if(pItem.isLess((Item) this.getRootItem()))
    { //gesuchter Knoteninhalt ist kleiner als betrachteter Knoteninhalt
      if(this.getLeftTree() == null)
      { //gesuchter Knoten ist nicht vorhanden und null wird zurckgegeben
        return null;
      }
      else
      { //rekursiver Aufruf fr den linken Teilbaum
        return ((OrderedTree)this.getLeftTree()).searchItem(pItem);
      }
    }
    else if(pItem.isGreater((Item) this.getRootItem()))
    { //gesuchter Knoteninhalt ist grer als betrachteter Knoteninhalt
      if(this.getRightTree() == null)
      { //gesuchter Knoten ist nicht vorhanden und null wird zurckgegeben
        return null;
      }
      else
      { //rekursiver Aufruf fr den rechten Teilbaum
        return ((OrderedTree)this.getRightTree()).searchItem(pItem);
      }
    }
    else //if(pItem.isEqual((Item) this.getRootItem()))
    { //gesuchter Knoten ist vorhanden und wird zurckgegeben
      return pItem;
    }
  }

  // Falls ein bezglich der verwendeten Ordnungsrelation mit pItem ber-
  // einstimmendes Objekt im Baum enthalten war, wurde dieses entfernt.
  public void removeItem(Item pItem)
  {
    //lschen nur in nichtleeren Bumen
    if(!this.isEmpty())
    {
      if(pItem.isGreater((Item) this.getRootItem()))
      { //zu lschender Knoteninhalt ist grer als betrachteter Knoteninhalt
        if(this.getRightTree() !=null)
        { //rekursiver Aufruf fr den rechten Teilbaum
          ((OrderedTree) getRightTree()).removeItem(pItem);
        }
      }
      else if(pItem.isLess((Item) this.getRootItem()))
      { //zu lschender Knoteninhalt ist kleiner als betrachteter Knoteninhalt
        if(this.getLeftTree()!=null)
        { //rekursiver Aufruf fr den linken Teilbaum
          ((OrderedTree) getLeftTree()).removeItem(pItem);
        }
      }
      else if(pItem.isEqual((Item) this.getRootItem()))
      { //zu lschenden Knoteninhalt gefunden
        if(getLeftTree() == null & getRightTree() == null)
        { //zu lschender Knoteninhalt ist ein Blatt
          clear();
        }
        else if(this.getLeftTree() == null)
        { //zu lschender Knoteninhalt hat nur einen rechten Teilbaum
          this.setRootItem(this.getRightTree().getRootItem());
          OrderedTree right = (OrderedTree) this.getRightTree();
          this.setLeftTree(right.getLeftTree());
          this.setRightTree(right.getRightTree());
        }
        else if(this.getRightTree() == null)
        { //zu lschender Knoteninhalt hat nur einen linken Teilbaum
          this.setRootItem(this.getLeftTree().getRootItem());
          OrderedTree left = (OrderedTree)this.getLeftTree();
          this.setLeftTree(left.getLeftTree());
          this.setRightTree(left.getRightTree());
        }
        else
        { //zu lschender Knoteninhalt hat zwei Teilbume
          Item minOfRightTree = ((OrderedTree)this.getRightTree()).getMinOfRightTree();
          ((OrderedTree)this.getRightTree()).removeItem(minOfRightTree);
          this.setRootItem(minOfRightTree);
        }
      }
      //Beseitigen von Teilbmen mit Knoteninhalt null
      //insbesondere beim rekursiven Aufstieg
      if(this.getRightTree() !=null)
      {
        if(this.getRightTree().getRootItem()==null)
        {
          this.setRightTree(null);
        }
      }
      if(this.getLeftTree() !=null)
      {
        if(this.getLeftTree().getRootItem()==null)
        {
          this.setLeftTree(null);
        }
      }
    }
  }
           
  public Item getMinOfRightTree()
  //Liefert den kleinsten Knoteninhalt im rechten Teilbaum
  {
    if(getLeftTree()!=null)
    {
      return ((OrderedTree) getLeftTree()).getMinOfRightTree();
    }
    else
      return (Item) getRootItem();
  }

  //Die Knoteninhalte des geordneten Binrbaums werden als sortierte Liste
  //zurckgegeben. Ist der geord.Baum leer, wird eine leere Liste zurckgegeben.
  public List getSortedList()
  {
    List geordneteTeilListe = new List();
    if(isEmpty()==false)
    {
      if(getLeftTree()!=null)
      { //Rekursiver Aufruf fr den linken Teilbaum
        geordneteTeilListe.addList(((OrderedTree)getLeftTree()).getSortedList());
      }
      //Einfgen der Wurzel
      geordneteTeilListe.insertBehind(((SuchbaumObject)getRootItem()).getInhalt());
      geordneteTeilListe.next();
      if(getRightTree()!=null)
      { //Rekursiver Aufruf fr den rechten Teilbaum
        geordneteTeilListe.addList(((OrderedTree)getRightTree()).getSortedList());
      }
    }
    return geordneteTeilListe;
  }

}
